
\subsubsection{Bounding Maximum Delay}
\label{sec:tfadelay}
An important notion throughout the remainder of the paper is that of
computing bounds on the allowable delays along all possible paths through a TFA. 
Specifically, we are interested in doing so to be able to reason formally about the maximum execution
time for a child process, with the end goal of being able to bound the execution time of the system--- parent and
all child processes--- as a whole. 

The idea is that we will ultimately use TFAs to represent the timing properties of a child
process. Paths through the automaton from its start state to an accepting state 
correspond to possible execution paths of the child process' code. Certainly, proving
a tight upper bound on the delay between two arbitrary points along an execution
path remains a very difficult problem, but to be clear, this is not our goal. Rather, our approach
involves modeling an execution path through a child process (and, by extension,
its corresponding timed automaton) using an \emph{event-based}
model, in which selected system events are modeled by transitions in the automaton,
and we rely on timing properties of the process to be guaranteed by the 
underlying RTOS process scheduler.
The problem of computing 
the worst-case delay through the automaton equates to
that of computing the maximum delay over all possible paths through the
automaton from its start state to its accepting state:
\[
\delayTFA[\atfa] = \max_{\apath\in\paths{\atfa}}
	{\pathdelay{\apath}{}{}}
\]
where 
\begin{itemize}
\item $\atfa=\tba{\Aalpha}{\astates}{\state[0]}{\state[f]}{\aclks}{\tbareln}{\ireln}{\creln}$ is the TFA
\item $\paths{\atfa}$ denotes the set of all paths in $\atfa$
from its start state $\state[0]$ to accepting state $\state[f]$, and 
\item $\pathdelay{\apath}{}{}$, for path $\apath=\path{\state[0],...,\state[f]}$, denotes the maximum delay 
from $\state[0]$ to $\state[f]$. That is, the maximum duration of any timed string $\pair{\astring}{\timeseq}$
such that $\pair{\state[0]...\state[f]}{\clkints}$ is a run of the string over $\atfa$ (for some $\clkints$).
\end{itemize}

\input{interactions}
%$\delayTFA$ and $\dmin$ are computed by the following algorithm:
%\input{delayTFA}

\endinput
